import { ComponentFixture, TestBed, waitForAsync } from '@angular/core/testing';
import { GitsearchTestModule } from '../../test.module';
import { BookmarkComponent } from 'app/bookmarks/bookmarks.component';
import { IUserWatchList } from 'app/shared/model/user-watch-list.model';
import { UserWatchListService } from 'app/entities/user-watch-list/user-watch-list.service';
import { CheckFrequency } from 'app/shared/model/enumerations/check-frequency.model';
import { of } from 'rxjs';

describe('Component Tests', () => {
  describe('Bookmarks Component', () => {
    let comp: BookmarkComponent;
    let fixture: ComponentFixture<BookmarkComponent>;
    let userWatchListService: UserWatchListService;

    beforeEach(
      waitForAsync(() => {
        TestBed.configureTestingModule({
          imports: [GitsearchTestModule],
          declarations: [BookmarkComponent],
        })
          .overrideTemplate(BookmarkComponent, '')
          .compileComponents();
      })
    );

    beforeEach(() => {
      fixture = TestBed.createComponent(BookmarkComponent);
      comp = fixture.componentInstance;
      userWatchListService = fixture.debugElement.injector.get(UserWatchListService);
    });

    const defaultWatchList: IUserWatchList[] = [
      {
        id: 1,
        name: 'My WatchList',
        checkFrequency: CheckFrequency.NEVER,
        userLogin: 'any',
        userId: 0,
      },
    ];

    it('Should call userWatchListService.findMyWatchlists on initial ngOnInit', () => {
      // GIVEN
      spyOn(userWatchListService, 'findMyWatchlists').and.returnValue(of({ body: defaultWatchList }));
      // WHEN,
      comp.ngOnInit();

      // THEN
      expect(userWatchListService.findMyWatchlists).toHaveBeenCalled();
    });
  });
});
